From ea0ce21a560afee4413b8b3fda9268094ddb07a3 Mon Sep 17 00:00:00 2001
From: "H.J. Lu" <hjl.tools@gmail.com>
Date: Wed, 25 Mar 2015 09:19:08 -0700
Subject: [PATCH 7/7] Add run-strip-test10.sh

	 * Makefile.am (TESTS): Add run-strip-test10.sh.
	 (EXTRA_DIST): Likewise.
	 * run-strip-test10.sh: New file.
	 * testfile-x32-d.bz2: Likewise.
	 * testfile-x32-debug.bz2: Likewise.
---
 tests/Makefile.am            |   4 ++--
 tests/run-strip-test10.sh    |   5 +++++
 tests/testfile-x32-d.bz2     | Bin 0 -> 1718 bytes
 tests/testfile-x32-debug.bz2 | Bin 0 -> 2227 bytes
 4 files changed, 7 insertions(+), 2 deletions(-)
 create mode 100755 tests/run-strip-test10.sh
 create mode 100755 tests/testfile-x32-d.bz2
 create mode 100755 tests/testfile-x32-debug.bz2

diff --git a/tests/Makefile.am b/tests/Makefile.am
index a73623d..2f42364 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -76,7 +76,7 @@ TESTS = run-arextract.sh run-arsymtest.sh newfile test-nlist \
 	newscn run-strip-test.sh run-strip-test2.sh \
 	run-strip-test3.sh run-strip-test4.sh run-strip-test5.sh \
 	run-strip-test6.sh run-strip-test7.sh run-strip-test8.sh \
-	run-strip-test9.sh \
+	run-strip-test9.sh run-strip-test10.sh \
 	run-strip-groups.sh run-strip-reloc.sh \
 	run-unstrip-test.sh run-unstrip-test2.sh run-unstrip-M.sh \
 	run-ecp-test.sh run-ecp-test2.sh run-alldts.sh \
@@ -156,7 +156,7 @@ EXTRA_DIST = run-arextract.sh run-arsymtest.sh \
 	     run-line2addr.sh run-elflint-test.sh testfile14.bz2 \
 	     run-strip-test4.sh run-strip-test5.sh run-strip-test6.sh \
 	     run-strip-test7.sh run-strip-test8.sh run-strip-groups.sh \
-	     run-strip-test9.sh \
+	     run-strip-test9.sh run-strip-test10.sh \
 	     run-strip-reloc.sh hello_i386.ko.bz2 hello_x86_64.ko.bz2 \
 	     hello_ppc64.ko.bz2 hello_s390.ko.bz2 hello_aarch64.ko.bz2 \
 	     run-unstrip-test.sh run-unstrip-test2.sh run-unstrip-M.sh\
diff --git a/tests/run-strip-test10.sh b/tests/run-strip-test10.sh
new file mode 100755
index 0000000..9621f7a
--- /dev/null
+++ b/tests/run-strip-test10.sh
@@ -0,0 +1,5 @@
+original=testfile-x32
+stripped=testfile-x32-d
+debugfile=testfile-x32-debug
+
+. $srcdir/run-strip-test.sh
diff --git a/tests/testfile-x32-d.bz2 b/tests/testfile-x32-d.bz2
new file mode 100755
index 0000000000000000000000000000000000000000..91c93af47a1cf6459c0878f8b918ed985f4ce468
GIT binary patch
diff --git a/tests/testfile-x32-debug.bz2 b/tests/testfile-x32-debug.bz2
new file mode 100755
index 0000000000000000000000000000000000000000..d6bf2193ef324a6b5a30780bd4991210a65179d7
GIT binary patch
-- 
2.1.0